From 5a753eca4a7c951e379441f3b4b42658f2f3edcc Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 22 2017 18:23:02 +0000
Subject: [PATCH 885/1001] Don't show the SSE error message when leaving the page


---

diff --git a/hubs/static/client/app/components/feed/ItemsGetter.jsx b/hubs/static/client/app/components/feed/ItemsGetter.jsx
index 75c50f9..dcfe7ca 100644
--- a/hubs/static/client/app/components/feed/ItemsGetter.jsx
+++ b/hubs/static/client/app/components/feed/ItemsGetter.jsx
@@ -11,6 +11,7 @@ export default class ItemsGetter extends React.Component {
     };
     this.sseSource = null;
     this.setupSSESource = this.setupSSESource.bind(this);
+    this.tearDownSSESource = this.tearDownSSESource.bind(this);
     this.handleSSEEvent = this.handleSSEEvent.bind(this);
     this.handleSSEEventError = this.handleSSEEventError.bind(this);
     this.loadFromServer = this.loadFromServer.bind(this);
@@ -23,17 +24,14 @@ export default class ItemsGetter extends React.Component {
 
   componentWillUnmount() {
     this.serverRequest.abort();
-    if (this.sseSource) {
-      this.sseSource.removeEventListener(
-        this.props.sseEventName, this.this.props.handleSSEEvent);
-      this.sseSource.removeEventListener('error', this.handleSSEEventError);
-    }
+    this.tearDownSSESource();
+    window.removeEventListener("beforeunload", this.tearDownSSESource);
   }
 
   setupSSESource() {
-    //if (!this.props.sseEventName || !this.props.handleSSEEvent) {
-    if (!this.props.sse.eventName || !this.props.sse.shouldReload) {
-      console.log("SSE auto-update is disabled");
+    if (!this.props.sse ||
+        !this.props.sse.eventName ||
+        !this.props.sse.shouldReload) {
       // Auto-update is disabled.
       return;
     }
@@ -47,6 +45,18 @@ export default class ItemsGetter extends React.Component {
     this.sseSource.addEventListener('error', this.handleSSEEventError);
     this.sseSource.addEventListener(
       this.props.sse.eventName, this.handleSSEEvent);
+    // This is necessary to avoid the error message being displayed right
+    // before the user changes page.
+    // Pretty much like: https://bugzilla.mozilla.org/show_bug.cgi?id=833462
+    window.addEventListener("beforeunload", this.tearDownSSESource);
+  }
+
+  tearDownSSESource() {
+    if (!this.sseSource) { return; }
+    this.sseSource.removeEventListener(
+      this.props.sse.eventName, this.handleSSEEvent);
+    this.sseSource.removeEventListener('error', this.handleSSEEventError);
+    this.sseSource = null;
   }
 
   handleSSEEvent(e) {
@@ -55,7 +65,8 @@ export default class ItemsGetter extends React.Component {
     }
   }
 
-  handleSSEEventError() {
+  handleSSEEventError(e) {
+    console.log(e);
     this.setState({
       sseError: ("Cannot auto-update the feed, you will have to refresh "
                 +"the page manually to see new elements.")

